add rescue, fix default pxe, ubuntu locale
[automated-distro-installer] / pxe-server
index 0bdd13401e4238995ca0ccec985c0ca88d7ddf73..ec4606012a9703d1f70e2088f051057cbd2e1c44 100755 (executable)
@@ -28,22 +28,36 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 usage() {
     cat <<EOF
-Usage: ${0##*/} [OPTIONS] TYPE [HOST]
-One line description
-
-TYPE is one of arch, plain, fai, or : for no pxe server.
-HOST makes the pxe server only for that specific host
-
--r         Don't redeploy fai config.
--a         Wait for 2 dhcp acks, then disable the pxe server after a delay.
-           First ack is for pxe boot, 2nd ack is for os boot. Sometimes
-           on debian, there is a 3rd one shortly after the 2nd. I can't remember
-           exactly why this caused a problem, but I'm hoping the sleep
-           will take care of it.
--w         Initially setup pxe, then wait like -a.
+Usage: ${0##*/} [OPTIONS] [HOST TYPE]
+Configure dnsmasq pxe server options and fai-chboot if appropriate.
+
+Without HOST TYPE, disable pxe server and fai server.
+
+HOST       A hostname known to the dhcp server, or default for all.
+TYPE       One of arch, plain, fai.
+
+
+-r         Don't redeploy fai config. For example, if there is a different host
+           that is mid-install.
+
+-a         Don't setup pxe, just Wait for 2 dhcp acks, then disable the pxe
+           server after a delay.  First ack is for pxe boot, 2nd ack is
+           for os boot. Sometimes on debian, there is a 3rd one shortly
+           after the 2nd. I can't remember exactly why this caused a
+           problem, but I'm hoping the sleep will take care of it.
+-S         Pass -S to fai-chboot.
+-w         Setup pxe, then wait like -a.
 -h|--help  Print help and exit
 
 
+Note, when switching between plain and arch, you will need to
+do something like:
+ssh wrt
+cd /mnt/usb
+rm tftpboot
+ln -s <arch/debian iso dir> tftpboot
+
+
 Note: Uses GNU getopt options parsing style
 EOF
     exit $1
@@ -51,16 +65,16 @@ EOF
 
 ##### begin command line parsing ########
 
-args=()
 redep=true
 acks=2
 wait=false
-temp=$(getopt -l help harw "$@") || usage 1
+temp=$(getopt -l help harSw "$@") || usage 1
 eval set -- "$temp"
 while true; do
     case $1 in
         -a) wait=true; set=false; shift ;;
         -r) redep=false; shift ;;
+        -S) chboot_arg=-S; shift ;;
         -w) wait=true; set=true; shift ;;
         -h|--help) usage ;;
         --) shift; break ;;
@@ -68,14 +82,18 @@ while true; do
     esac
 done
 
-read type host <<<"$@"
+read -r host type <<<"$@"
 
-if [[ ! $type ]]; then
-    echo "$0: error: exptected 1 argument of type"
-    usage 1
-fi
+case $# in
+    0|2);;
+    *)
+        echo "$0: error: expected 0 or 2 arguments"
+        echo
+        usage 1
+        ;;
+esac
 
-if [[ $host ]]; then
+if [[ $host && $host != default ]]; then
     host_tag="tag:$host,"
 fi
 
@@ -104,8 +122,7 @@ EOF
 
 fai() {
     cat <<EOF
-$set_host_tag
-dhcp-boot=${host_tag}fai/pxelinux.0,faiserver.lan,faiserver.lan
+dhcp-boot=${host_tag}pxelinux.0,faiserver.lan,faiserver.lan
 EOF
 }
 
@@ -116,8 +133,7 @@ ack-wait() {
     fi
     regex=".*DHCPACK.*$host_regex$"
     i=0
-    tmp=$(mktemp)
-    while (( i != wait_count )) && read line; do
+    while (( i != wait_count )) && read -r line; do
         if [[ $line =~ $regex ]]; then
             i=$((i+1))
             echo $line
@@ -127,19 +143,22 @@ ack-wait() {
 }
 
 set-pxe() {
-    ${1:-$type} | ssh wrt "cedit pxe-server /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
-if [[ $type == arch ]]; then arch-pxe-mount; fi"
+    ${type:-:}|ssh wrt "cedit pxe /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
+$([[ $type == arch ]] && echo arch-pxe-mount)"
 }
 
 
 if $set; then
     set-pxe
-
     if [[ $type == fai ]]; then
+        e myfai-chboot $chboot_arg $host
         if $redep; then
-            fai-redep
+            fai-redep
         fi
-        faiserver-enable
+    else
+        # This will fail if faiserver is not setup, so ignore any
+        # failure and don't bother us about it.
+        myfai-chboot &>/dev/null ||:
     fi
 fi
 
@@ -150,7 +169,8 @@ if $wait; then
     # bleh.
     echo "waiting for $acks dhcp acks then disabling pxe"
     ack-wait $acks
-    set-pxe :
+    type=
+    set-pxe
 
     # previously tried waiting for one more ack then disabling faiserver,
     # since it can contain sensitive info, so turn it off when not in use,